Leetcode之K-diff Pairs in an Array 问题

问题描述:

Given an array of integers and an integer k, you need to find the number of unique k-diff pairs in the array. Here a k-diff pair is defined as an integer pair (i, j), where i and j are both numbers in the array andtheir absolute difference is k.

示例:

Example 1:

Input: [3, 1, 4, 1, 5], k = 2
Output: 2
Explanation: There are two 2-diff pairs in the array, (1, 3) and (3, 5).
Although we have two 1s in the input, we should only return the number of unique pairs.

Example 2:

Input:[1, 2, 3, 4, 5], k = 1
Output: 4
Explanation: There are four 1-diff pairs in the array, (1, 2), (2, 3), (3, 4) and (4, 5).

Example 3:

Input: [1, 3, 1, 5, 4], k = 0
Output: 1
Explanation: There is one 0-diff pair in the array, (1, 1).

问题来源:K-diff Pairs in an Array (详细地址:https://leetcode.com/problems/k-diff-pairs-in-an-array/description/)

思路分析:在这我们首先采用Hashmap来解决,因为hashmap的查找效率非常高,但是有一个问题:如果k=0的话,hashmap只会存一个。所以在这把k=0的情况单独拿出来,我们把key存为数组中的元素,value存为他们出现的次数,k=0的情况就可以用出现次数超过两次来解决了!其他的k != 0的情况,我们就直接看map中有没有但钱遍历的key + k的值存在。如果有我们就累计一次。

代码:

Leetcode之K-diff Pairs in an Array 问题